#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <semaphore.h>
#include <string.h>
#include <unistd.h>
#define CHECK(op) do { if ((op) == -1) { perror(#op); exit(1); } } while (0);
#define CHECKNULL(op) do { if ((op) == NULL) { perror(#op); exit(1); } } while (0);
#define MAXC 10 +1
#define PLACES 5
#define FICHIER "fichier"


char *lireligne(char *dest, int n, FILE *stream)
{
    char *s = fgets(dest, n, stream);
    if (s!=NULL)
    {
        s[strlen(s)-1] = '\0';
    }
    return s;
}

int main(int argc, char *argv[])
{
  
    FILE *fichier;
    if(!strcmp(argv[1],"controler"))
    {
        // --- debut control
        CHECKNULL(fichier = fopen(FICHIER,"a"));
        CHECK(fclose(fichier));

        sem_t *fichierouvert;
        CHECKNULL(fichierouvert = sem_open("/" FICHIER, O_CREAT, 0777, 1));
        CHECK(sem_close(fichierouvert));
        sem_t *participants;
        CHECKNULL(participants = sem_open("/nbparticipants", O_CREAT, 0777, PLACES));

        int libre = -1;
        
        while (1)
        {
            int nb;
            CHECK(sem_getvalue(participants, &nb));
            int i = (nb == PLACES);
            if (i != libre)
            {
                libre = i;
                if (libre)
                {
                    printf("salle libre");
                }
                else
                {
                    printf("salle occupée");
                }
                
                
            }
            
        }
        // --- fin control
    }
    else if(!strcmp(argv[1],"nettoyer"))
    {
        // --- debut nettoyage

        sem_unlink("/" FICHIER);
        sem_unlink("/nbparticipants");

        CHECK(unlink(FICHIER));

        // --- fin nettoyage
    }
    else
    {
        if(argc!=4)
        {
            fprintf(stderr,"%s réunion nom durée \n", argv[0]);
            exit(EXIT_FAILURE);
        }
        FILE *fichier;
        char *reunion= argv[1];
        char *nom = argv[2];
        int duree=atoi(argv[3]);

        if (strlen(reunion) >= MAXC)
        {
            fprintf(stderr, "réunion trop longue \n");
            exit(EXIT_FAILURE);

        }
        else if (strlen(nom) >= MAXC)
        {
            fprintf(stderr, "nom trop long \n");
            exit(EXIT_FAILURE);
        }
        
        
        
        sem_t *fichierouvert;
        CHECKNULL(fichierouvert = sem_open("/" FICHIER, 0));
        sem_t *nbparticipants;
        CHECKNULL(nbparticipants = sem_open("/nbparticipants", 0));

        CHECK(sem_wait(fichierouvert));
        CHECKNULL(fichier = fopen(FICHIER, "r"));
        
        char reunioncourante[MAXC];
        if (lireligne(reunioncourante, MAXC, fichier) == NULL)
        {
            strncpy(reunioncourante, reunion, MAXC);
        }

        int nb=0;
        char participants[PLACES][MAXC];
        while (nb<PLACES && lireligne(participants[nb], MAXC, fichier) != NULL)
        {
            nb++;
        }

        if (nb>0 && strncmp(reunion, reunioncourante, MAXC))
        {
            fprintf(stderr, "mauvaise réunion \n");
            CHECK(sem_post(fichierouvert));
            exit(EXIT_FAILURE);
        }
        else if(nb>=PLACES)
        {
            fprintf(stderr, "salle pleine \n");
            CHECK(sem_post(fichierouvert));
            exit(EXIT_FAILURE);
        }
        
        CHECK(fclose(fichier));
        CHECK(sem_trywait(nbparticipants));

        CHECKNULL(fichier = fopen(FICHIER, "a"));
        fprintf(fichier, "%s\n", nom);
        CHECK(fclose(fichier));
        CHECK(sem_post(fichierouvert));

        CHECK(usleep(duree*1000));

        CHECK(sem_wait(fichierouvert));
        CHECKNULL(fichier = fopen(FICHIER, "r"));
        CHECKNULL(lireligne(reunioncourante, MAXC, fichier));
        nb=0;
        while (nb<PLACES && lireligne(participants[nb], MAXC, fichier) != NULL)
        {
            nb++;
        }
        CHECK(fclose(fichier));
        CHECKNULL(fichier = fopen(FICHIER, "w"));
        fprintf(fichier, "%s\n", reunioncourante);
        for (int i = 0; i < nb; i++)
        {
            fprintf(fichier, "%s\n", participants[i]);
        }
        CHECK(fclose(fichier));
        CHECK(sem_post(nbparticipants));
        CHECK(sem_post(fichierouvert));
         // ca compile !!
        
    }

    return 0;
}
