#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>

#define CHECK(op, msg) { if ((op) == -1) { perror(msg); exit(1); } }

struct computearg_t
{
    long long int p, t, u;
};

void *compute(void *arg)
{
    arg->u = 0;

    for (long long int i = 1; i <= arg->p; i++)
        arg->u += (arg->t - 1) * arg->p + i;
    
    pthread_exit(arg);
}

int main(int argc, char const *argv[])
{
    if (argc != 3)
    {
        fprintf(stderr, "bad usage: %s <n> <p>", argv[0]);
        return 1;
    }

    long long int n = atoi(argv[1]);
    long long int p = atoi(argv[2]);
    
    pthread_t *threads = malloc(n*sizeof(pthread_t));
    struct computearg_t *args = malloc(n*sizeof(struct computearg_t));

    for (long long int i = 0; i < n; i++)
    {
        args[i].p = p;
        args[i].t = i + 1;

        CHECK(pthread_create(&threads[i], NULL, compute, &args[i]), "create");
    }
    
    long long int u = 0;

    for (long long int i = 0; i < n; i++)
    {
        CHECK(pthread_join(threads[i], NULL), "join");

        u += args[i].u;
    }

    free(threads);
    free(args);
    
    printf("Ut calculé : %lld\nUt espéré  : %lld\n", u, n*p*(n*p+1)/2);

    return 0;
}
